---
title: Firefox 61 for developers
slug: Mozilla/Firefox/Releases/61
tags:
  - '61'
  - Firefox
  - Release
---
<div>{{FirefoxSidebar}}</div>

<p class="summary">This article provides information about the changes in Firefox 61 that will affect developers. Firefox 61 was released on June 26, 2018.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<ul>
 <li>The new-look Console UI has been enabled by default for the <a href="/en-US/docs/Tools/Browser_Console">Browser Console</a> &amp; <a href="/en-US/docs/Tools/Browser_Toolbox">Browser Toolbox</a> ({{bug(1362023)}}/{{bug(1347127)}}). The old UI has been removed.</li>
 <li>In the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a>, clicking <em>Open in New Tab</em> in a <code>POST</code> request's context menu correctly resends the request with the expected <code>POST</code> parameters ({{bug(1407515)}}).</li>
 <li><a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS#CSS_variable_autocompletion">CSS variables now autocomplete</a> with color swatches, allowing you to see exactly what color value is stored in each variable ({{bug(1451211)}}).
  <ul>
   <li>In addition, hovering over a CSS variable name brings up a tooltip showing what color value is stored in that variable ({{bug(1431949)}}).</li>
  </ul>
 </li>
 <li>The main toolbox's toolbar has been redesigned. Highlights are better responsiveness for narrow and wide viewports with a new overflow dropdown, cleaned up meatball menu, and sortable tabs to let you move up your most used panels ({{bug(1226272)}}).</li>
 <li>The <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a>'s toolbar now includes a dropdown menu providing easier access to the 'Copy All As HAR' and 'Save All As HAR' commands, as well as an 'Import...' option ({{bug(1403530)}}).</li>
 <li>The Network Monitor's details pane now includes a <a href="/en-US/docs/Tools/Network_Monitor#Cache">Cache tab</a>, which displays information about previously cached resources ({{bug(859051)}}).</li>
 <li>The Network Monitor's main toolbar got redesigned to be more responsive on smaller viewports and visually aligned with the Console.</li>
 <li>The Network Monitor's main toolbar now includes a <a href="/en-US/docs/Tools/Network_Monitor#Throttling">Throttling</a> dropdown which was only available in the <a href="/en-US/docs/Tools/Responsive_Design_Mode#Network_throttling">Responsive Design Mode</a> before. It allows you to throttle your network speed to emulate various different network speed conditions ({{bug(1349559)}}).</li>
 <li>The Browser Console now hides CSS errors by default for readability and performance reasons ({{bug(1452143)}}).</li>
 <li>The Browser Console now includes a command to restart the browser. Use <kbd>Ctrl</kbd> + <kbd>Alt</kbd> + <kbd>R</kbd> (Windows, Linux) or <kbd>Cmd</kbd> + <kbd>Alt</kbd> + <kbd>R</kbd> (Mac) to restart the browser with the same tabs open as before the restart.</li>
 <li>DevTools' web extension APIs <code><a href="/en-US/docs/">devtools.network.onRequestFinished</a></code> ({{bug(1311171)}}) and <code><a href="https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/devtools.network/getHAR">devtools.network.getHAR</a></code> ({{bug(1311177)}}) got implemented (enabling extensions like <a href="/en-US/docs/">har-export-trigger</a>).</li>
 <li>The Firebug theme got removed since the transition of Firebug users into DevTools is complete ({{bug(1378108)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<p><em>No changes.</em></p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>CSS parsing has been parallelized ({{bug(1346988)}}).</li>
 <li>Support for {{cssxref("font-variation-settings")}} and {{cssxref("font-optical-sizing")}} has been enabled by default ({{bug(1447163)}}).</li>
 <li>The <code>grid-gap</code>, <code>grid-row-gap</code>, and <code>grid-column-gap</code> properties have been renamed to {{cssxref("gap")}}, {{cssxref("row-gap")}}, and {{cssxref("column-gap")}}, as they are no longer grid-specific ({{bug(1398482)}}). See <a href="/en-US/docs/Web/CSS/CSS_Box_Alignment#Gaps_between_boxes">Box alignment; Gaps between boxes</a> for additional details. The old names have been kept as aliases for web compatibility purposes.</li>
 <li>The {{cssxref("flex-basis")}} <code>content</code> value is now supported ({{bug(1105111)}}).</li>
 <li>Percentage values of {{cssxref("column-gap")}} are now supported in <a href="/en-US/docs/Web/CSS/CSS_Columns">CSS multi-column layout</a> ({{bug(1398537)}}).</li>
 <li>The CSS {{cssxref(":host")}} pseudo-class is now supported; this selects a custom element from inside its shadow DOM ({{bug(992245)}}).</li>
 <li>{{cssxref("overflow")}} now accepts two-value syntax ({{bug(1453148)}}).</li>
 <li>Flex items that are sized according to their content are now sized using <code>max-content</code>, not <code>fit-content</code> ({{bug(1282821)}}). See the <a href="/en-US/docs/Web/CSS/width#Values"><code>width</code> value definitions</a> for more details of these values.</li>
 <li>{{cssxref("font-weight")}}, {{cssxref("font-stretch")}} and {{cssxref("font-style")}} now support additional values as defined by <a href="https://drafts.csswg.org/css-fonts-4/">CSS Fonts level 4</a> ({{bug(1436048)}}):
  <ul>
   <li>{{cssxref("font-weight")}} now accepts a floating-point value between 1 and 1000 inclusive.</li>
   <li>{{cssxref("font-stretch")}} now accepts percentage values.</li>
   <li>{{cssxref("font-style")}} now accepts an angle after the <code>oblique</code> keyword.</li>
  </ul>
 </li>
 <li>The {{cssxref("@font-face")}} descriptor equivalents of the three properties mentioned in the above entry also support the new syntax listed above, and additionally now support a two-value syntax allowing us to specify a range of descriptor values supported by a font-face ({{bug(1436061)}}, {{bug(1436048)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<ul>
 <li>The <code>ping</code>, <code>rel</code>, <code>referrerPolicy</code>, <code>relList</code>, <code>hreflang</code>, <code>type</code> and <code>text</code> properties have been added to the {{SVGElement("a")}} element ({{domxref("SVGAElement")}}) to be consistent with the HTML {{HTMLElement("a")}} element ({{bug("1451823")}}).</li>
 <li>The {{SVGElement("textPath")}} element ({{domxref("SVGTextPathElement")}}) now supports the SVG2 <code>path</code> and <code>side</code> attributes ({{bug("1446617")}} and {{bug("1446650")}}).</li>
 <li>The {{domxref("SVGGeometryElement")}} interface is now supported for more elements and not just for the {{SVGElement("path")}} element ({{bug("1325320")}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The {{jsxref("String.prototype.trimStart()")}} and {{jsxref("String.prototype.trimEnd()")}} methods have been implemented (see {{bug(1434007)}}). <code>trimLeft</code> and <code>trimRight</code> remain as aliases for web compatibility reasons.</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="New_APIs">New APIs</h4>

<ul>
 <li>The {{domxref("PerformanceServerTiming")}} API has been implemented. It surfaces server-side metrics sent via the {{HTTPHeader("Server-Timing")}} header ({{bug(1423495)}}).</li>
</ul>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The {{domxref("Document.anchors", "anchors")}}, {{domxref("Document.applets", "applets")}}, {{domxref("Document.embeds", "embeds")}}, {{domxref("Document.forms", "forms")}}, {{domxref("Document.head", "head")}}, {{domxref("Document.images", "images")}}, {{domxref("Document.links", "links")}}, {{domxref("Document.plugins", "plugins")}}, and {{domxref("Document.scripts", "scripts")}} properties have been moved from the {{domxref("HTMLDocument")}} interface onto {{domxref("Document")}} ({{bug(1415588)}}).</li>
 <li>{{domxref("DOMTokenList.replace()")}} now returns a boolean value to indicate whether the replacement occurred successfully, rather than void ({{bug(1444909)}}).</li>
 <li>The <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a>'s {{domxref("Request.credentials")}} property now defaults to <code>"same-origin"</code> per the latest revision of the specification ({{bug(1394399)}}).</li>
 <li>The {{domxref("Request.destination")}} property has been implemented ({{bug(1402892)}}).</li>
 <li>The {{domxref("MutationObserver")}} option dictionary, {{domxref("MutationObserverInit")}}, no longer has <code>false</code> as the default value of all of its Boolean properties. Now, only <code>childList</code> and <code>subtree</code> have default values (of <code>false</code> still). The other properties have no default values ({{bug(973638)}}).</li>
 <li>The <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> method {{domxref("PaymentRequest.show()")}} now supports using a {{jsxref("Promise")}} to let the client side code provide updated payment details prior to activating the payment interface ({{bug(1441709)}}).</li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<p><em>No changes.</em></p>

<h4 id="Service_workers">Service workers</h4>

<p>The "Forget" button, available in Firefox's customization options, now clears service workers and their caches ({{bug(1252998)}}).</p>

<h4 id="Web_Audio_Media_and_WebRTC">Web Audio, Media and WebRTC</h4>

<ul>
 <li>The {{domxref("AudioContext.AudioContext", "AudioContext()")}} constructor now accepts an optional <code>options</code> parameter of type {{domxref("AudioContextOptions")}}. This lets you configure the preferred latency and/or sample rate for the new context.</li>
 <li>Firefox now throws the correct exceptions when instantiation of an {{domxref("AudioBuffer")}} fails.</li>
</ul>

<h4 id="WebVR">WebVR</h4>

<ul>
 <li>The <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a> has been enabled by default on macOS ({{bug(1244242)}}).</li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<p><em>No changes.</em></p>

<h4 id="CSSOM">CSSOM</h4>

<ul>
 <li>The {{domxref("CSSStyleRule.selectorText")}} property is now fully implemented and no longer read-only ({{bug(37468)}}).</li>
 <li>The {{domxref("MediaList")}} interface implementation is now a little closer to the specification. It is not all the way there yet; for example, stringifier attributes haven't been implemented yet ({{bug(1455807)}}).</li>
</ul>

<h3 id="HTTP">HTTP</h3>

<ul>
 <li>The cookie directive <code><strong>SameSite</strong></code> has been implemented. See <a href="/en-US/docs/Web/HTTP/Headers/Set-Cookie">Set-Cookie</a> and <a href="/en-US/docs/Web/HTTP/Cookies">HTTP cookies</a> ({{bug(795346)}}).</li>
</ul>

<h3 id="Networking">Networking</h3>

<ul>
 <li>Firefox 61 and later no longer support using the FTP protocol (that is, URLs with the <code>"ftp://"</code> scheme) to load subresources from within HTML content. FTP is still supported as a top-level URL entered directly into the URL bar or loaded as a standalone document ({{bug(1404744)}}).</li>
</ul>

<h3 id="Security">Security</h3>

<p><em>No changes.</em></p>

<h3 id="Plugins">Plugins</h3>

<p><em>No changes.</em></p>

<h3 id="Other">Other</h3>

<p><em>No changes.</em></p>

<h2 id="Removals_from_the_web_platform">Removals from the web platform</h2>

<h3 id="Developer_tools_2">Developer tools</h3>

<p><kbd>Cmd</kbd>/<kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>O</kbd> no longer shows/hides the DevTools options panel — use <kbd>F1</kbd> instead ({{bug(1409456)}}).</p>

<h3 id="HTML_2">HTML</h3>

<p><em>No changes.</em></p>

<h3 id="CSS_2">CSS</h3>

<p><code>@-moz-document</code> has been disabled in content pages ({{bug(1422245)}}).</p>

<h3 id="APIs_2">APIs</h3>

<ul>
 <li>The {{domxref("File")}} interface's property {{domxref("File.lastModifiedDate", "lastModifiedDate")}} has been removed ({{bug(1458883)}}).</li>
 <li>The {{domxref("Node.getUserData()")}} and {{domxref("Node.setUserData()")}} methods have been removed from the platform completely ({{bug(749981)}}).</li>
 <li>The {{domxref("Element.createShadowRoot()")}} method has been removed. Use {{domxref("Element.attachShadow()")}} instead ({{bug(1453789)}}).</li>
 <li>The {{domxref("MediaStream")}} overload of the {{domxref("URL.createObjectURL()")}} method has been removed ({{bug(1454889)}}).</li>
</ul>

<h3 id="SVG_2">SVG</h3>

<ul>
 <li>The deprecated (and never properly implemented) {{domxref("SVGViewElement")}}<code>.viewTarget</code> property has been removed ({{bug(1455763)}}).</li>
 <li>The following deprecated properties have been removed from {{domxref("SVGSVGElement")}} ({{bug(1133172)}}):
  <ul>
   <li><code>pixelUnitToMillimeterX</code></li>
   <li><code>pixelUnitToMillimeterY</code></li>
   <li><code>screenPixelToMillimeterX</code></li>
   <li><code>screenPixelToMillimeterY</code></li>
  </ul>
 </li>
 <li>The non-standard <code>SVGNumber()</code> constructor has been removed ({{bug("1455940")}}).</li>
</ul>

<h3 id="Other_2">Other</h3>

<p><em>No changes.</em></p>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<h3 id="WebExtensions">WebExtensions</h3>

<ul>
 <li>Autocomplete popups are now themeable ({{bug(1417883)}}).</li>
 <li><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/onUpdated">tabs.onUpdated</a></code> now has a filter template ({{bug(1329507)}}).</li>
 <li>The default document colors can now be overridden, using <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserSettings/overrideDocumentColors">browserSettings.overrideDocumentColors</a></code> ({{bug(1417810)}}).</li>
 <li><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/query">tabs.query</a> has been optimized with the implementation of some useful search/filter option parameters ({{bug(1445316)}}).</li>
 <li>You can now use <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/permissions/request">permissions.request</a></code> from an <code>about:addons</code> preferences page ({{bug(1382953)}}).</li>
 <li>You can now force web pages to use system fonts instead of the fonts they specify using the <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserSettings/useDocumentFonts">browserSettings.useDocumentFonts</a></code> property ({{bug("1400805")}}).</li>
 <li>You can now cause browser search autocomplete suggestions to automatically open in a new tab rather than the current tab using the<code> </code><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserSettings/openUrlbarResultsInNewTabs">browserSettings.openUrlbarResultsInNewTabs</a></code> property ({{bug("1432645")}}).</li>
 <li>You can control whether the user can close a tab using double-click with the  <a class="new" href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/browserSettings/closeTabsByDoubleClick" rel="nofollow" title="The documentation about this has not yet been written; please consider contributing!"><code>browserSettings.closeTabsByDoubleClick</code></a> property ({{bug("1435142")}}).</li>
 <li>The <code>toolbar</code>, <code>toolbar_text</code>, <code>toolbar_field</code>, <code>toolbar_field_text</code>, and <code>toolbar_field_border</code> <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/theme">theme</a> manifest properties now also apply to the findbar ({{bug(1418605)}}).</li>
 <li>In <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/sidebarAction/getPanel">sidebarAction.getPanel()</a></code>, <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/sidebarAction/getTitle">sidebarAction.getTitle()</a></code>, <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/sidebarAction/setPanel">sidebarAction.setPanel()</a></code>, <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/sidebarAction/setTitle">sidebarAction.setTitle()</a></code>, and <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/sidebarAction/setIcon">sidebarAction.setIcon()</a></code>, you can now specify a <code>windowId</code> so that the features will be set/got only for a specific window ({{bug(1390464)}}).</li>
 <li><code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/hide">tabs.hide()</a></code> and <code><a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/tabs/show">tabs.show()</a></code> are now enabled by default ({{bug(1455040)}}).
  <ul>
   <li>The first time an extension hides a tab, the browser will tell the user that the tab is being hidden, show them how they can access the hidden tab, and give them the option of disabling the extension instead ({{bug(1438363)}}).</li>
  </ul>
 </li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/61">Site compatibility for Firefox 61</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(60)}}</p>

